       SUBROUTINE CROSSOVER(MATE1,MATE2,INUM)  
       USE SHARED_DATA
	 USE UPPERLEVEL
	 USE LOWERLEVEL
	 IMPLICIT REAL*8(A-H,O-Z) 

       CALL RANDOM(1,RND)

	 IF (IRANK==0) THEN
C      UPPER LEVEL: 2D BINARY CROSSOVER OPERATOR OVER THE COMMONALITY CHROMOSOME	  
	   IF (RND<=PC) THEN
C      PERFORM CROSSOVER
        	 CALL RANDOM(1,RND)
	     CROSS1=INT((PRONUM-1)*RND+1)  ! PICKS FIRST CROSS SITE AT RANDOM
	     IF (CROSS1==PRONUM) CROSS1=PRONUM-1
           CROSS2=INT((VARNUM-1)*RND+1)  ! PICKS SECOND CROSS SITE AT RANDOM
	     IF (CROSS2==VARNUM) CROSS2=VARNUM-1
	     QUAD=INT(4.0D0*RND+1)         ! PICKS THE QUADRANT FOR INTERCHANGE
           IF (QUAD==5) QUAD=4

	     IF (QUAD==1) THEN
C     IF QUAD=1 INTERCHANGE THE 1ST QUADRANTS BETWEEN PARENTS (MATE1 & MATE2)                                                                                                                                                                                                                                                                                                                                                                                                               
	       DO I=1,PRONUM
	         DO J=1,VARNUM
	           IF (I<=CROSS1.AND.J<=CROSS2) THEN
                   NEWCHROM1(I,J,INUM)=CHROM1(I,J,MATE2)
                   NEWCHROM1(I,J,INUM+1)=CHROM1(I,J,MATE1)
	           ELSE
	             NEWCHROM1(I,J,INUM)=CHROM1(I,J,MATE1)
                   NEWCHROM1(I,J,INUM+1)=CHROM1(I,J,MATE2)
	           ENDIF
	         ENDDO
	       ENDDO

 	     ELSEIF (QUAD==2) THEN
C     IF QUAD=2 INTERCHANGE THE 2ND QUADRANTS BETWEEN PARENTS (MATE1 & MATE2)                                                                                                                                                                                                                                                                                                                                                                                                               
	       DO I=1,PRONUM
	         DO J=1,VARNUM
	           IF (I<=CROSS1.AND.J>CROSS2) THEN
                   NEWCHROM1(I,J,INUM)=CHROM1(I,J,MATE2)
                   NEWCHROM1(I,J,INUM+1)=CHROM1(I,J,MATE1)
	           ELSE
	             NEWCHROM1(I,J,INUM)=CHROM1(I,J,MATE1)
                   NEWCHROM1(I,J,INUM+1)=CHROM1(I,J,MATE2)
	           ENDIF
	         ENDDO
	       ENDDO

	     ELSEIF (QUAD==3) THEN
C     IF QUAD=3 INTERCHANGE THE 3RD QUADRANTS BETWEEN PARENTS (MATE1 & MATE2)                                                                                                                                                                                                                                                                                                                                                                                                               
	       DO I=1,PRONUM
	        DO J=1,VARNUM
	           IF (I>CROSS1.AND.J<=CROSS2) THEN
                   NEWCHROM1(I,J,INUM)=CHROM1(I,J,MATE2)
                   NEWCHROM1(I,J,INUM+1)=CHROM1(I,J,MATE1)
	           ELSE
	             NEWCHROM1(I,J,INUM)=CHROM1(I,J,MATE1)
                   NEWCHROM1(I,J,INUM+1)=CHROM1(I,J,MATE2)
	           ENDIF
		    ENDDO
	       ENDDO

	     ELSEIF (QUAD==4) THEN
C     IF QUAD=4 INTERCHANGE THE 4TH QUADRANTS BETWEEN PARENTS (MATE1 & MATE2)
	       DO I=1,PRONUM
	        DO J=1,VARNUM
	           IF (I>CROSS1.AND.J>CROSS2) THEN
                   NEWCHROM1(I,J,INUM)=CHROM1(I,J,MATE2)
                   NEWCHROM1(I,J,INUM+1)=CHROM1(I,J,MATE1)
	           ELSE
	             NEWCHROM1(I,J,INUM)=CHROM1(I,J,MATE1)
                   NEWCHROM1(I,J,INUM+1)=CHROM1(I,J,MATE2)
	           ENDIF
	        ENDDO
	       ENDDO
	 
	     ENDIF
        
	   ELSE
C     DON'T PERFORM CROSSOVER
	     NEWCHROM1(:,:,INUM)=CHROM1(:,:,MATE1)
	     NEWCHROM1(:,:,INUM+1)=CHROM1(:,:,MATE2)

         ENDIF

	 ELSE
C      LOWER LEVELS: SIMULATED BINARY CROSSOVER OPERATOR OVER DESIGN CHROMOSOMES
      
        IF (RND<=PC) THEN
	    DO I=1,VARNUM
	      CALL RANDOM(1,RND)
	      IF (RND<=5.0D-1) THEN
	        BETA=(2.0D0*RND)**(1.0D0/(ETAC+1.0D0))
            ELSE
	        BETA=(5.0D-1/(1.0D0-RND))**(1.0D0/(ETAC+1.0D0))
	      ENDIF
	      NEWCHROM2(INUM,I)=5.0D-1*((1.0D0+BETA)*CHROM2(MATE1,I)+
	1	                    (1.0D0-BETA)*CHROM2(MATE2,I))
	      IF  (I<=2) THEN
	        NEWCHROM2(INUM,I)=INT(NEWCHROM2(INUM,I))   
            ELSE		
		    NEWCHROM2(INUM,I)=1.0D-3*INT(NEWCHROM2(INUM,I)*1.D3+0.5)
	      ENDIF
		    
            NEWCHROM2(INUM+1,I)=5.0D-1*((1.0D0-BETA)*CHROM2(MATE1,I)+
	1	                     (1.0D0+BETA)*CHROM2(MATE2,I))
	      IF (I<=2) THEN
               NEWCHROM2(INUM+1,I)=INT(NEWCHROM2(INUM+1,I))
	      ELSE
		     NEWCHROM2(INUM+1,I)=1.0D-3*INT(NEWCHROM2(INUM+1,I)*1.D3
	1           		             +5.0D-1)
	      ENDIF
	    ENDDO
	  ELSE
          NEWCHROM2(INUM,:)=CHROM2(MATE1,:)
	    NEWCHROM2(INUM+1,:)=CHROM2(MATE2,:)
        ENDIF

       ENDIF

	END SUBROUTINE