	 SUBROUTINE FINDFITNESS(IGEN)
C	 ASSIGNES A FITNESS TO EACH PARENT POPULATION MEMBER
       USE SHARED_DATA
	 USE UPPERLEVEL
	 USE LOWERLEVEL
       IMPLICIT REAL*8(A-H,O-Z)
	 INCLUDE 'MPIF.H'
      
	 INTEGER::STATUS(MPI_STATUS_SIZE)
	 CHARACTER*2::EXT
	 WRITE(EXT,'(I2)') IRANK
       
      
	 DO I=1,POPNUM
	    
	   SUBMASS=0.0;SUBVIO=0.0;SUBEFF=0.0	    
	   TOTMASS=0.0;TOTVIO=0.0;TOTEFF=0.0
         AVEMASS=0.0;AVEVIO=0.0;AVEEFF=0.0
	    
	   IF (IRANK.NE.0) THEN
C      LOWER LEVELS WRITE THE DESIGN VARIABLES IN INPUT FILES FOR THE MOTOR EXAMPLE  
C      (INPUT FILES ARE CALLED MOTOR.*.INP WHICH * DEIFINES THE NODE NUMBER)           
	     OPEN(12+IRANK,FILE='MOTOR'//EXT//'.INP')
           DO J=1,VARNUM
		    WRITE(12+IRANK,*) CHROM2(I,J)
		 ENDDO     
		 WRITE(12+IRANK,*) OUT_TORQUE
	     WRITE(12+IRANK,*) OUT_POWER
	     CLOSE(12+IRANK)  
C      THE MOTOR EXECUTABLE FILE IS CALLED FOR CALCULATING THE MOTOR PARAMETERS 
C      RUNMOTOR. EXE CALCS THE OUTPUT PARAMETERS AND WRITE THEM INTO OUTPUT FILES
C      (OUTPUT FILES ARE CALLED MOTOR.*.OUT WHICH * DEIFINES THE NODE NUMBER)
           CALL SYSTEM('runmotor'//EXT//'.exe')

C      LOWER LEVELS READ THE MOTOR OUTPUT VALUES FROM THE CORRESPONDING OUTPUT FILES
		 OPEN(13+IRANK,FILE='MOTOR'//EXT//'.OUT')
           READ(13+IRANK,*) MASS
	     READ(13+IRANK,*) EFF
	     READ(13+IRANK,*) LENGTH
           READ(13+IRANK,*) AWA
	     READ(13+IRANK,*) FEAS
	     READ(13+IRANK,*) H
	     CLOSE(13+IRANK)

	     
	     IF (EFF>1.0) EFF=EFF-INT(EFF)
	     IF (MASS<0) MASS=1.0D3
C          CALCS THE CONSTRAINT VIOLATION VALUE FOR EACH MOTOR	       
		 CALL VIOLATION(VIO)
C          PERFORMANCE OBJECTIVE FOR EACH VARIANT       
		 FITNESS1(I)=5.0D-1*(EFF+(1.0D0-5.0D-1*MASS))-IGEN*VIO
C          SENDING THE PERFORMANCE PARAMETERS OF EACH VARIANT TO THE UPPER LEVEL
		 CALL MPI_SEND(MASS,1,MPI_DOUBLE_PRECISION,0,1,MPI_COMM_WORLD
	1	              ,IERR)
           CALL MPI_SEND(EFF,1,MPI_DOUBLE_PRECISION,0,2,MPI_COMM_WORLD
	1	              ,IERR)
	     CALL MPI_SEND(VIO,1,MPI_DOUBLE_PRECISION,0,3,MPI_COMM_WORLD
	1	              ,IERR)
C          RECEIVING THE COMMONALITY VALUE FROM THE UPPER LEVEL
	     CALL MPI_RECV(COMMVAL,1,MPI_DOUBLE_PRECISION,0,IRANK,MPI_COMM
	1	               _WORLD,STATUS,IERR)
C          COMMNALITY OBJECTIVE FUNCTION 
		 FITNESS2(I)=COMMVAL/MAXCOMMONALITY-IGEN*VIO
             
	     IF (FITNESS1(I)<0) FITNESS1(I)=0.0
           IF (FITNESS2(I)<0) FITNESS2(I)=0.0  

	  ELSE
		  
	     DO II=1,P-1 
C      RECEIVING THE PERFORMANCE PARAMETERS FROM LOWER LEVELS AND CALCULATING THE
C      AVERAGE VALUE FOR THE PRODUCT FAMILY PERFORMANCE OBJECTIVE
		   CALL MPI_RECV(SUBMASS,1,MPI_DOUBLE_PRECISION,II,1,MPI_COMM_
	1	                 WORLD,STATUS,IERR)	
             CALL MPI_RECV(SUBEFF,1,MPI_DOUBLE_PRECISION,II,2,MPI_COMM_
	1	                 WORLD,STATUS,IERR)
	       CALL MPI_RECV(SUBVIO,1,MPI_DOUBLE_PRECISION,II,3,MPI_COMM_
	1	                 WORLD,STATUS,IERR)
	        

	       TOTMASS=SUBMASS+TOTMASS
             TOTEFF=SUBEFF+TOTEFF
	       TOTVIO=SUBVIO+TOTVIO

           ENDDO

		 AVEMASS=TOTMASS/(P-1)
		 AVEEFF=TOTEFF/(P-1)
		 AVEVIO=TOTVIO/(P-1)	
C      PRODUCT FAMILY PERFORMANCE OBJECTIVE           
	     FITNESS1(I)=5.0D-1*(AVEEFF+(1.D0-5.0D-1*AVEMASS))-IGEN*AVEVIO
C      COMMONALITY VALUE (BASED ON COMMONALITY INDEX)
	     CALL VARIANCE(I)
C      COMMONALITY OBJECTIVE	     
		 FITNESS2(I)=COMMVAL/MAXCOMMONALITY-IGEN*AVEVIO
C      SENDING THE COMMONALITY VALUE TO LOWER LEVELS         
	     DO II=1,P-1
		    CALL MPI_SEND(COMMVAL,1,MPI_DOUBLE_PRECISION,II,II,
	1                	  MPI_COMM_WORLD,IERR)
           ENDDO
        
		 IF (FITNESS1(I)<0) FITNESS1(I)=0.0
           IF (FITNESS2(I)<0) FITNESS2(I)=0.0

	  ENDIF
           
	 ENDDO
       

 	 ENDSUBROUTINE

