       SUBROUTINE MODIFYCROSSOVER(IGEN)
C      MODIFIES THE OFFSPRING POPULATION ACCORDING TO THE CONSISTENCY SONSTRAINTS
	 USE SHARED_DATA
	 USE UPPERLEVEL
	 USE LOWERLEVEL
	 IMPLICIT REAL*8(A-H,O-Z)
       INCLUDE 'MPIF.H'
	 INTEGER::MATIND(PRONUM,PRONUM+1,VARNUM),INDX(PRONUM)
	 REAL*8::TCHROM(VARNUM,PRONUM+1)
	 INTEGER,ALLOCATABLE::MEMBERS(:)
	 REAL*8,ALLOCATABLE::MCH(:)
	 
       MATIND=0
	 DO I=1,POPNUM
	   
	   IF (IRANK==0) THEN
C      COMMONALITY CONSISTENCY CONSTRAINT
	     MATIND(:,1,:)=1
	     DO II=1,PRONUM
	       MATIND(II,2:PRONUM+1,:)=II  
	     ENDDO
	       
	     DO J=1,VARNUM
	       INDX=3
	       DO K=2,PRONUM
	         DO KK=1,K-1
	           IF (NEWCHROM1(K,J,I)==NEWCHROM1(KK,J,I)) THEN
	             MATIND(KK,1,J)=MATIND(KK,1,J)+1
	             MATIND(KK,INDX(KK),J)=K
	             INDX(KK)=INDX(KK)+1
	             EXIT
	           ENDIF
	         ENDDO
	       ENDDO
	     ENDDO
         
         ELSE
	     DO J=1,VARNUM
	        IF (NEWCHROM2(I,J)<RANGES(1,J)) NEWCHROM2(I,J)=RANGES(1,J)
	        IF (NEWCHROM2(I,J)>RANGES(2,J)) NEWCHROM2(I,J)=RANGES(2,J)
	     ENDDO
	   ENDIF
		 
        CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)
  
         CALL MPI_BCAST(MATIND(1,1,1),PRONUM*(PRONUM+1)*VARNUM,
	1                  MPI_INTEGER,0,MPI_COMM_WORLD,IERR)
 
	  
	   
	   DO J=1,VARNUM
	     DO K=1,PRONUM
		   IF(MATIND(K,1,J)>1) THEN
                 
               SUM=0.0
			 ALLOCATE(MEMBERS(MATIND(K,1,J)),MCH(MATIND(K,1,J)))
	         MEMBERS=MATIND(K,2:MATIND(K,1,J)+1,J)
	         
	         DO IJ=2,MATIND(K,1,J)
	            IF (IRANK==MEMBERS(IJ)) THEN   
	               CALL MPI_SEND(NEWCHROM2(I,J),1,MPI_DOUBLE_PRECISION
     1                             ,MEMBERS(1),0,MPI_COMM_WORLD,IERR)
                     CALL MPI_RECV(NEWCHROM2(I,J),1,MPI_DOUBLE_PRECISION
     1                             ,MEMBERS(1),1,MPI_COMM_WORLD,STATUS,
     1                             IERR)
	            ENDIF
               ENDDO  
	     
	         IF (IRANK==MEMBERS(1)) THEN
	            MCH(1)=NEWCHROM2(I,J)
			     DO II=2,MATIND(K,1,J)
	                CALL MPI_RECV(MCH(II),1,MPI_DOUBLE_PRECISION,
     1                              MEMBERS(II),0,MPI_COMM_WORLD,STATUS
     1                             ,IERR)
					MCH(1)=MCH(1)+MCH(II)
	             ENDDO
	             NEWCHROM2(I,J)=MCH(1)/MATIND(K,1,J)
	             IF (J<=2) THEN
	                NEWCHROM2(I,J)=INT(NEWCHROM2(I,J))
	             ELSE
	               NEWCHROM2(I,J)=1.0D-3*INT(NEWCHROM2(I,J)*1.D3+0.5)
                   ENDIF

	             DO II=2,MATIND(K,1,J)
	                CALL MPI_SEND(NEWCHROM2(I,J),1,MPI_DOUBLE_
     1                             PRECISION,MEMBERS(II),1,MPI_COMM_
     1                               WORLD,IERR)
	             ENDDO
	          ENDIF
               
			 DEALLOCATE(MEMBERS,MCH)
        
		   ENDIF
		 ENDDO
           
	   ENDDO  
	   CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)

	   CALL MPI_GATHER(NEWCHROM2(I,1),1,NEWTYP1,TCHROM,VARNUM,
	1                   MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,IERR)         
        	  
	  IF (IRANK==0) THEN
C       DESIGN VARIABLE CONSISTENCY CONSTRAINT
	     DO J=1,VARNUM
	        DO II=2,PRONUM
			   DO IJ=1,II
	              IF (NEWCHROM1(II,J,I).NE.NEWCHROM1(IJ,J,I)) THEN
				     IF (TCHROM(J,II+1)==TCHROM(J,IJ+1)) THEN
	                     NEWCHROM1(II,J,I)=NEWCHROM1(IJ,J,I) 
	                     EXIT
	                 ENDIF
	              ENDIF
	           ENDDO
	        ENDDO
	      ENDDO
	  ENDIF

	 	
	 ENDDO
	
	END SUBROUTINE







