       SUBROUTINE MODIFYPOP
	 USE SHARED_DATA
	 USE UPPERLEVEL
	 USE LOWERLEVEL
	 IMPLICIT REAL*8(A-H,O-Z)
	 REAL*8,ALLOCATABLE::CONTROL(:,:)
	 INTEGER::MATIND(PRONUM,PRONUM+1,VARNUM),INDX(PRONUM)
	 REAL*8::CONTROL1(VARNUM,2,PRONUM),TCHROM(VARNUM,PRONUM+1)
	 REAL*8,ALLOCATABLE::CONTROL2(:,:)

	 CHARACTER*1::EXT
	 INCLUDE 'MPIF.H'

       WRITE(EXT,'(I1)') IRANK
C      DEFINES DIMENSTION OF CONTROL MATRICES: NUMBER OF SHARED VARABLES
       
	 CALL MPI_TYPE_VECTOR(2,1,VARNUM,MPI_DOUBLE_PRECISION,NEWT,IERR)
	 CALL MPI_TYPE_COMMIT(NEWT,IERR)

	 DO I=1,POPNUM
	   CONTROL1=0.0
	   IF (IRANK==0) THEN
	     MATIND(:,1,:)=1
	     DO II=1,PRONUM
	       MATIND(II,2:PRONUM+1,:)=II  
	     ENDDO
	       
	     DO J=1,VARNUM
	       INDX=3
	       DO K=2,PRONUM
	         DO KK=1,K-1
	           IF (CHROM1(K,J,I)==CHROM1(KK,J,I)) THEN
	             MATIND(KK,1,J)=MATIND(KK,1,J)+1
	             MATIND(KK,INDX(KK),J)=K
	             INDX(KK)=INDX(KK)+1
	             EXIT
	           ENDIF
	         ENDDO
	       ENDDO
	     ENDDO
           
		 INDX=1
		 DO J=1,VARNUM
	       DO K=1,PRONUM
	         IF (MATIND(K,1,J)>1) THEN
	           CALL RANDOM(1,RND)
	           VAL=RND*(RANGES(2,J)-RANGES(1,J))+RANGES(1,J)
	           DO IJ=1,MATIND(K,1,J)
	             CONTROL1(INDX(MATIND(K,IJ+1,J)),1,MATIND(K,IJ+1,J))=J
                   CONTROL1(INDX(MATIND(K,IJ+1,J)),2,MATIND(K,IJ+1,J))=
	1			                                                   VAL
	             INDX(MATIND(K,IJ+1,J))=INDX(MATIND(K,IJ+1,J))+1
	           ENDDO
	         ENDIF
	       ENDDO
	    ENDDO
	    INDX=INDX-1
          
	   	DO I1=1,PRONUM
	       CALL MPI_SEND(INDX(I1),1,MPI_INTEGER,I1,2*I1,MPI_COMM_WORLD
	1	                 ,IERR)
	       DO I2=1,INDX(I1)
	          CALL MPI_SEND(CONTROL1(i2,1,I1),1,newt,I1,I1,MPI_COMM_
	1                        WORLD,IERR)
	       ENDDO

	   ENDDO
	
	  ELSE
           
          CALL MPI_RECV(ISIZE,1,MPI_INTEGER,0,2*IRANK,MPI_COMM_WORLD,
	1	              STATUS,IERR)
	    IF (ISIZE>=1) THEN
	    
		CALL MPI_TYPE_VECTOR(2,1,ISIZE,MPI_DOUBLE_PRECISION,TYP2,IERR)
	    CALL MPI_TYPE_COMMIT(TYP2,IERR)
          
	    ALLOCATE(CONTROL2(ISIZE,2))
         
	    DO II=1,ISIZE
	       CALL MPI_RECV(CONTROL2(II,1),1,TYP2,0,IRANK,MPI_COMM_WORLD
	1	                 ,STATUS,IERR)
	    ENDDO

		CALL MPI_TYPE_FREE(TYP2,IERR)
	    
		
	    DO IJ=1,ISIZE
	      CHROM2(I,CONTROL2(IJ,1))=CONTROL2(IJ,2)
	      IF (CONTROL2(IJ,1)<=2) THEN
			 CHROM2(I,CONTROL2(IJ,1))=INT(CHROM2(I,CONTROL2(IJ,1)))
	      ELSE
			 CHROM2(I,CONTROL2(IJ,1))=1.0D-3*INT(CHROM2(I,CONTROL2(IJ
     1			                     ,1))*1.D3+0.5)
            ENDIF
	    ENDDO
           
          DEALLOCATE(CONTROL2)
	 
	 ENDIF
	     
	  ENDIF 
	  
	   CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)

	   CALL MPI_GATHER(CHROM2(I,1),1,NEWTYP1,TCHROM,VARNUM,
	1                   MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,IERR)

         
        	  
	  IF (IRANK==0) THEN
	     DO J=1,VARNUM
	        DO II=2,PRONUM
			   DO IJ=1,II
	              IF (CHROM1(II,J,I).NE.CHROM1(IJ,J,I)) THEN
				     IF (TCHROM(J,II+1)==TCHROM(J,IJ+1)) THEN
	                     CHROM1(II,J,I)=CHROM1(IJ,J,I) 
	                     EXIT
	                 ENDIF
	              ENDIF
	           ENDDO
	        ENDDO
	      ENDDO
	  ENDIF
 
		
	 ENDDO

	 
	 ENDSUBROUTINE 