       SUBROUTINE MUTATION
C      MUTATION OPERATORS
	 USE SHARED_DATA
	 USE UPPERLEVEL
	 USE LOWERLEVEL
       IMPLICIT REAL*8(A-H,O-Z)
	 INCLUDE 'MPIF.H'
	 
	 REAL*8,ALLOCATABLE::X(:,:)
       INTEGER::IND(VARNUM)
	 
	
	 DO II=1,POPNUM
	 
	  IND=0;N1=0;N2=0
	 
	  IF (IRANK==0) THEN
C       UPPER LEVEL: 2D FLIPPING MUTATION OPERATOR
        	   DO I=1,VARNUM
	          CALL RANDOM(1,RND)
	          IF (RND<=PM) THEN
	             CALL RANDOM(1,RND)
	             IF (RND<=1.0D-1) THEN 
C      THE DESIGN VARIABLE BECOMES COMMON AMONG ENTIRE VARIANTS
	                 IND(I)=1
	                 N1=N1+1
			     ELSE
C      THE DESIGN VARIABLE BECOMES DISTINCT IN THE FAMILY
			         IND(I)=-1
				     N2=N2+1
			     ENDIF
		       ENDIF
	        ENDDO
	   ENDIF


	   CALL MPI_BCAST(N1,1,MPI_INTEGER,0,MPI_COMM_WORLD,IERR)
	   CALL MPI_BCAST(N2,1,MPI_INTEGER,0,MPI_COMM_WORLD,IERR)
	   CALL MPI_BCAST(IND(1),VARNUM,MPI_INTEGER,0,MPI_COMM_WORLD,IERR)
	   
	   IF (N1.NE.0) ALLOCATE(X(N1,2))
	 
	 
	   IF (IRANK==0) THEN
	      J=1;K=1
	      DO I=1,VARNUM
	         IF (IND(I)==1) THEN
	            CALL RANDOM(1,RND)
	            X(J,1)=I
	            X(J,2)=RND*(RANGES(2,I)-RANGES(1,I))+RANGES(1,I)
	            IF (I<=2) X(J,2)=INT(X(J,2))
				IF (I>2)  X(J,2)=1.0D-3*INT(X(J,2)*1.D3+0.5)
	            CALL RANDOM(1,RND)
                  IVAL=INT((PRONUM*RND+1))  
	            IF (IVAL==PRONUM+1) IVAL=PRONUM
                  NEWCHROM1(:,I,II)=IVAL
	            J=J+1
	         ElSEIF (IND(I)==-1) THEN
	            DO K=1,PRONUM
				  CALL RANDOM(1,RND)
                    IND1=INT(RND*PRONUM+1)
	              IF (IND1==PRONUM+1) IND1=PRONUM
	              IF (K>1) THEN
100	                 DO IJ=1,K-1
	                   IF (IND1==CHROM1(IJ,I,II)) THEN
	                      CALL RANDOM(1,RND)
	                      IND1=INT(RND*PRONUM+1)
	                      IF (IND1==PRONUM+1) IND1=PRONUM
                            GOTO 100
	                    ENDIF
	                  ENDDO
	                ENDIF
	                NEWCHROM1(K,I,II)=IND1
	              ENDDO
			  ENDIF
	      ENDDO
	   ENDIF

	   IF (N1.NE.0) CALL MPI_BCAST(X(1,1),N1*2,MPI_DOUBLE_PRECISION,0,
	1                               MPI_COMM_WORLD,IERR)

	   IF (IRANK.NE.0) THEN
C       LOWER LEVELS: POLYNOMIAL MUTATION OPERATOR
	      IF (N2.NE.0) THEN
	        DO I=1,VARNUM
                IF (IND(I)==-1) THEN            
	            CALL RANDOM(1,RND)
	            IF (RND<5.0D-1) THEN
	               DELTA=(2.0D0*RND)**(1.0D0/(ETAM+1.0D0))-1.0D0
	            ELSE
	               DELTA=1.0D0-(2.0D0*(1.0D0-RND))**(1.0D0/(ETAM
	1				     +1.0D0))
	            ENDIF
	            NEWCHROM2(II,I)=NEWCHROM2(II,I)+DELTA*(RANGES(2,I)-
	1			                RANGES(1,I))
	            IF (I<=2) THEN
	              NEWCHROM2(II,I)=INT(NEWCHROM2(II,I))
	            ELSE
                    NEWCHROM2(II,I)=1.0D-3*INT(NEWCHROM2(II,I)*1.D3+0.5)
	            ENDIF

                ENDIF
		    ENDDO
	      ENDIF
	
	      IF (N1.NE.0) THEN
	         DO I=1,N1
	            NEWCHROM2(II,X(I,1))=X(I,2)
	         ENDDO
            ENDIF	 
	   ENDIF
	 
	   IF (N1.NE.0) DEALLOCATE(X)

	ENDDO
	
		
	END SUBROUTINE	       
       
