	 SUBROUTINE REPLACE(IGEN)
C      REPLACE THE PARENTS POULATION BY THE NEW POPULATION
C      THE UPPER LEVEL SELECTS THE BEST HALF ACCORDING TO NSGAII SCHEME
C      ALL LOWER LEVELS SELECT THE NEXT POPULATION MEMBERS ACCORDINGLY
	 USE SHARED_DATA
	 USE UPPERLEVEL
	 USE LOWERLEVEL
       IMPLICIT REAL*8(A-H,O-Z)
	 include 'mpif.h'	 
	 
	 INTEGER::NEWIND(POPNUM)
	 REAL*8::MIDFIT1(VARNUM),MIDFIT2,MFITNESS1(POPNUM),
	1        MFITNESS2(POPNUM),MCHROM2(POPNUM,VARNUM)
	 INTEGER::MCHROM(PRONUM,VARNUM,POPNUM)
	 REAL*8::TOTFIT1(2*POPNUM),TOTFIT2(2*POPNUM),FIT1(POPNUM),
     1	     FIT2(POPNUM),TOTFIT11(2*POPNUM),TOTFIT22(2*POPNUM)
	 INTEGER::FRONT(2*POPNUM),SCRAP(2*POPNUM),R(2*POPNUM)
	 INTEGER::IND(2*POPNUM)
	 REAL*8,ALLOCATABLE::DIST(:)
       PARAMETER(F1MIN=0.0,F1MAX=1.0D0,F2MIN=0.0D0,F2MAX=1.0D0)
	

       
	  IF (IRANK==0) THEN
C	 UPPER LEVEL: SELECT THE NEW POPULATION ACCORDING TO NSGA2 SCHEME	 
	   TOTFIT1(1:POPNUM)=FITNESS1(1:POPNUM)
	   TOTFIT1(POPNUM+1:2*POPNUM)=NEWFITNESS1(1:POPNUM)
         TOTFIT2(1:POPNUM)=FITNESS2(1:POPNUM)
	   TOTFIT2(POPNUM+1:2*POPNUM)=NEWFITNESS2(1:POPNUM)
	   TOTFIT11=TOTFIT1;TOTFIT22=TOTFIT2
	   FIT1=FITNESS1;FIT2=FITNESS2;MCHROM=CHROM1
	   II=0;IK=1;CR=0
	   FRONT=0;SCRAP=0;FRONT(1)=1;IFRONT=0;IST=0
	
	 
	  DO
	   IFRONT=IFRONT+1
	   K=1 
	   DO I=2,2*POPNUM
	      N=0
	      IF (TOTFIT1(I).NE.1.0D12.AND.TOTFIT2(I).NE.1.0D12.AND.I.NE.
	1          FRONT(1)) THEN

	          DO J=1,K
	             IF (FRONT(J).NE.0) THEN
	                IF (TOTFIT1(I)>=TOTFIT1(FRONT(J)).AND.TOTFIT2(I)>=
	1		            TOTFIT2(FRONT(J))) THEN 
                           FRONT(J)=0
                           N=N+1
	                ELSEIF (TOTFIT1(I)<=TOTFIT1(FRONT(J)).AND.TOTFIT2
	1		                (I)<=TOTFIT2(FRONT(J))) THEN
	                         EXIT
	                ELSE
	                       N=N+1
	                ENDIF

	              ELSE
	                N=N+1
	             ENDIF
	          ENDDO

	      ENDIF

	      IF (N==K) THEN
	          FRONT(K+1)=I
	          K=K+1
	      ENDIF
	   ENDDO

	   IJ=II
	   DO I=1,2*POPNUM
	    IF (FRONT(I).NE.0) THEN
	       R(FRONT(I))=IFRONT
	       II=II+1
	    ENDIF
	   ENDDO
	   IF (II>=POPNUM) THEN
	       CR=1
	       GOTO 100
	   ELSE
C       REPLACEMENT
	     DO I=1,2*POPNUM
	       IF (FRONT(I).NE.0) THEN
	        IF (R(FRONT(I))==IFRONT) THEN
	           IF (FRONT(I)<=POPNUM) THEN
	              FITNESS1(IK)=FIT1(FRONT(I))
                    FITNESS2(IK)=FIT2(FRONT(I)) 
	        	  CHROM1(:,:,IK)=MCHROM(:,:,FRONT(I))
	              NEWIND(IK)=FRONT(I)
	              IK=IK+1
	           ELSE
	              FITNESS1(IK)=NEWFITNESS1(FRONT(I)-POPNUM)
                    FITNESS2(IK)=NEWFITNESS2(FRONT(I)-POPNUM)
	              CHROM1(:,:,IK)=NEWCHROM1(:,:,FRONT(I)-POPNUM)
	              NEWIND(IK)=FRONT(I)
	              IK=IK+1
	           ENDIF
	        ENDIF
	       ENDIF
	     ENDDO
	     K=1 

	     DO I=1,2*POPNUM
	        IF (FRONT(I).NE.0) THEN
	            TOTFIT1(FRONT(I))=1.0D12
	            TOTFIT2(FRONT(I))=1.0D12
	            SCRAP(K+IST)=FRONT(I)
	            K=K+1
	        ENDIF
	     ENDDO
	
	     DO I=1,2*POPNUM 
	        COUNT=0
	        DO J=1,2*POPNUM
	           IF (SCRAP(J)==I) THEN
	               EXIT
	           ELSE
	               COUNT=COUNT+1
	           ENDIF
	        ENDDO
	        IF (COUNT==2*POPNUM) THEN
	           FRONT(1)=I
	           EXIT
	        ENDIF
	     ENDDO

	     FRONT(2:2*POPNUM)=0

	  ENDIF
	  IST=II

	 ENDDO
       

100    IF (CR==1) THEN
C      CALC. CROWDING DISTANCE FOR THE FRONT 
C     SORTING FOR THE FIRST OBJECTIVE FUNCTION
       K=0;MIND=0;IND=0
	 DO J=1,2*POPNUM
	    IF (FRONT(J).NE.0) THEN
	        IF (R(FRONT(J))==IFRONT) THEN
	           K=K+1
	           IND(K)=FRONT(J)
	        ENDIF
	    ENDIF
	 ENDDO
	 DO II=1,K-1
	    DO JJ=1,K-1
	       IF (TOTFIT11(IND(JJ+1))>TOTFIT11(IND(JJ))) THEN
	           MIND=IND(JJ)
	           IND(JJ)=IND(JJ+1)
	           IND(JJ+1)=MIND
	        ENDIF
	     ENDDO
	 ENDDO
	 ALLOCATE(DIST(K))

	
	 DIST(1)=1.0D12;DIST(K)=1.0D12
	 
	 DO J=2,K-1
	    DIST(J)=ABS(TOTFIT22(IND(J+1))-TOTFIT22(IND(J-1)))/(F2MAX-
	1	            F2MIN)+ABS(TOTFIT11(IND(J+1))-TOTFIT11(IND(J-1)
     1                ))/(F1MAX-F1MIN)
	 ENDDO
	
C      SORTING FOR THE CROWDING DISTANCE
       MIND=0.0
       DO II=1,K-1
	    DO JJ=1,K-1
	       IF (DIST(JJ+1)>=DIST(JJ)) THEN
	           DIST1=DIST(JJ)
	           DIST(JJ)=DIST(JJ+1)
	           DIST(JJ+1)=DIST1
	           MIND=IND(JJ)
	           IND(JJ)=IND(JJ+1)
	           IND(JJ+1)=MIND 
	       ENDIF
	    ENDDO
	 ENDDO

C      PUTTING THE LAST FRONT MEMBERS WITH LARGER CROWDING DISTANCE IN THE NEW POPULATION
       DO I=1,POPNUM-IJ
	    IF (IND(I)<=POPNUM) THEN
	        FITNESS1(IK)=FIT1(IND(I))
              FITNESS2(IK)=FIT2(IND(I))
	        CHROM1(:,:,IK)=MCHROM(:,:,IND(I))
	        NEWIND(IK)=IND(I)
	        IK=IK+1
	    ELSE

	       FITNESS1(IK)=NEWFITNESS1(IND(I)-POPNUM)
             FITNESS2(IK)=NEWFITNESS2(IND(I)-POPNUM)
	       CHROM1(:,:,IK)=NEWCHROM1(:,:,IND(I)-POPNUM)
	       NEWIND(IK)=IND(I)
	       IK=IK+1
	    ENDIF
	 ENDDO

	 ENDIF

       ENDIF
C      UPPER LEVEL SENDS THE REQUIRED DATA TO ALL LOWER LEVELS INDICATING
C      WHICH MEMEBERS SHOULD GO TO THE NEXT GENERATION
	 CALL MPI_BCAST(NEWIND(1),POPNUM,MPI_INTEGER,0,MPI_COMM_WORLD,IERR)

	 IF (IRANK.NE.0) THEN
C      LOWER LEVELS: REPLACE THE OLD POPULATION TO THE NWE ONE ACCORDING TO
C      THE UPPER LEVEL
	    MFITNESS1=FITNESS1
	    MFITNESS2=FITNESS2
          MCHROM2=CHROM2

	    DO I=1,POPNUM
	      IF (NEWIND(I)<=POPNUM) THEN
              CHROM2(I,:)=MCHROM2(NEWIND(I),:)
	        FITNESS1(I)=MFITNESS1(NEWIND(I))
	        FITNESS2(I)=MFITNESS2(NEWIND(I))
            ELSE
	        CHROM2(I,:)=NEWCHROM2(NEWIND(I)-POPNUM,:)
	        FITNESS1(I)=NEWFITNESS1(NEWIND(I)-POPNUM)
	        FITNESS2(I)=NEWFITNESS2(NEWIND(I)-POPNUM)
	      ENDIF
	    ENDDO

	 ENDIF
      

	 ENDSUBROUTINE

